(function(){

// This controls the drop chance of mob eggs.
// NOT A PERCENT, this is a multiplier. 
// This means 1.0 is 100%, and 0.01 is 1%
let EGG_DROP_CHANCE = 0.01;

// This controls which mobs drop eggs.
// It is a mapping of mob id to the item id of the spawn egg.
// Some mobs are omitted from this mapping because they are special cases:
//      * Sporelings drop different items depending on whether they are the nether variety
let EGGS = {
    "minecraft:allay": "minecraft:allay_spawn_egg",
    "minecraft:axolotl": "minecraft:axolotl_spawn_egg",
    "minecraft:bat": "minecraft:bat_spawn_egg",
    "minecraft:bee": "minecraft:bee_spawn_egg",
    "minecraft:blaze": "minecraft:blaze_spawn_egg",
    "minecraft:cat": "minecraft:cat_spawn_egg",
    "minecraft:cave_spider": "minecraft:cave_spider_spawn_egg",
    "minecraft:chicken": "minecraft:chicken_spawn_egg",
    "minecraft:cod": "minecraft:cod_spawn_egg",
    "minecraft:cow": "minecraft:cow_spawn_egg",
    "minecraft:creeper": "minecraft:creeper_spawn_egg",
    "minecraft:dolphin": "minecraft:dolphin_spawn_egg",
    "minecraft:donkey": "minecraft:donkey_spawn_egg",
    "minecraft:drowned": "minecraft:drowned_spawn_egg",
    //"minecraft:elder_guardian": "minecraft_elder_guardian_spawn_egg", // Disabled: boss mob
    "minecraft:enderman": "minecraft:enderman_spawn_egg",
    "minecraft:endermite": "minecraft:endermite_spawn_egg", 
    //"minecraft:evoker": "minecraft:evoker_spawn_egg", // Disabled: op totem farm
    "minecraft:fox": "minecraft:fox_spawn_egg",
    "minecraft:frog": "minecraft:frog_spawn_egg",
    "minecraft:ghast": "minecraft:ghast_spawn_egg",
    "minecraft:glow_squid": "minecraft:glow_squid_spawn_egg",
    "minecraft:goat": "minecraft:goat_spawn_egg",
    "minecraft:guardian": "minecraft:guardian_spawn_egg",
    "minecraft:hoglin": "minecraft:hoglin_spawn_egg",
    "minecraft:horse": "minecraft:horse_spawn_egg",
    "minecraft:husk": "minecraft:husk_spawn_egg",
    "minecraft:llama": "minecraft:llama_spawn_egg",
    "minecraft:magma_cube": "minecraft:magma_cube_spawn_egg",
    "minecraft:mooshroom": "minecraft:mooshroom_spawn_egg",
    "minecraft:mule": "minecraft:mule_spawn_egg",
    "minecraft:ocelot": "minecraft:ocelot_spawn_egg",
    "minecraft:panda": "minecraft:panda_spawn_egg",
    "minecraft:parrot": "minecraft:parrot_spawn_egg",
    "minecraft:phantom": "minecraft:phantom_spawn_egg",
    "minecraft:pig": "minecraft:pig_spawn_egg",
    "minecraft:piglin": "minecraft:piglin_spawn_egg",
    "minecraft:piglin_brute": "minecraft:piglin_brute_spawn_egg",
    "minecraft:pillager": "minecraft:pillager_spawn_egg",
    "minecraft:polar_bear": "minecraft:polar_bear_spawn_egg",
    "minecraft:pufferfish": "minecraft:pufferfish_spawn_egg",
    "minecraft:rabbit": "minecraft:rabbit_spawn_egg",
    "minecraft:ravager": "minecraft:ravager_spawn_egg",
    "minecraft:salmon": "minecraft:salmon_spawn_egg",
    "minecraft:sheep": "minecraft:sheep_spawn_egg",
    "minecraft:shulker": "minecraft:shulker_spawn_egg",
    "minecraft:silverfish": "minecraft:silverfish_spawn_egg",
    "minecraft:skeleton": "minecraft:skeleton_spawn_egg",
    "minecraft:skeleton_horse": "minecraft:skeleton_horse_spawn_egg",
    "minecraft:slime": "minecraft:slime_spawn_egg",
    "minecraft:spider": "minecraft:spider_spawn_egg",
    "minecraft:squid": "minecraft:squid_spawn_egg",
    "minecraft:stray": "minecraft:stray_spawn_egg",
    "minecraft:strider": "minecraft:strider_spawn_egg",
    "minecraft:tadpole": "minecraft:tadpole_spawn_egg",
    "minecraft:trader_llama": "minecraft:trader_llama_spawn_egg",
    "minecraft:tropical_fish": "minecraft:tropical_fish_spawn_egg",
    "minecraft:turtle": "minecraft:turtle_spawn_egg",
    "minecraft:vex": "minecraft:vex_spawn_egg",
    //"minecraft:villager": "minecraft:villager_spawn_egg", // Disabled: infinite trader
    "minecraft:vindicator": "minecraft:vindicator_spawn_egg",
    //"minecraft:wandering_trader": "minecraft:wandering_trader_spawn_egg", // Disabled: infinite trader
    //"minecraft:warden": "minecraft:warden_spawn_egg", // Disabled: griefing
    "minecraft:witch": "minecraft:witch_spawn_egg",
    "minecraft:wither_skeleton": "minecraft:wither_skeleton_spawn_egg",
    "minecraft:wolf": "minecraft:wolf_spawn_egg",
    "minecraft:zoglin": "minecraft:zoglin_spawn_egg",
    "minecraft:zombie": "minecraft:zombie_spawn_egg",
    "minecraft:zombie_horse": "minecraft:zombie_horse_spawn_egg",
    //"minecraft:zombie_villager": "minecraft:zombie_villager_spawn_egg", // Disabled: infinite trader
    "minecraft:zombified_piglin": "minecraft:zombified_piglin_spawn_egg",

    "alexsmobs:alligator_snapping_turtle": "alexsmobs:spawn_egg_alligator_snapping_turtle",
    "alexsmobs:anaconda": "alexsmobs:spawn_egg_anaconda",
    "alexsmobs:anteater": "alexsmobs:spawn_egg_anteater",
    "alexsmobs:bald_eagle": "alexsmobs:spawn_egg_bald_eagle",
    "alexsmobs:banana_slug": "alexsmobs:spawn_egg_banana_slug",
    "alexsmobs:bison": "alexsmobs:spawn_egg_bison",
    "alexsmobs:blobfish": "alexsmobs:spawn_egg_blobfish",
    "alexsmobs:blue_jay": "alexsmobs:spawn_egg_blue_jay",
    //"alexsmobs:bone_serpent": "alexsmobs:spawn_egg_bone_serpent", // Disabled: griefing
    "alexsmobs:bunfungus": "alexsmobs:spawn_egg_bunfungus",
    //"alexsmobs:cachalot_whale": "alexsmobs:spawn_egg_cachalot_whale", // Disabled: griefing
    "alexsmobs:capuchin_monkey": "alexsmobs:spawn_egg_capuchin_monkey",
    //"alexsmobs:catfish": "alexsmobs:spawn_egg_catfish", // Disabled: catfish are causing problems atm
    "alexsmobs:centipede_head": "alexsmobs:spawn_egg_centipede",
    "alexsmobs:cockroach": "alexsmobs:spawn_egg_cockroach",
    "alexsmobs:comb_jelly": "alexsmobs:spawn_egg_comb_jelly",
    "alexsmobs:cosmaw": "alexsmobs:spawn_egg_cosmaw",
    "alexsmobs:cosmic_cod": "alexsmobs:spawn_egg_cosmic_cod",
    "alexsmobs:crimson_mosquito": "alexsmobs:spawn_egg_crimson_mosquito",
    "alexsmobs:crocodile": "alexsmobs:spawn_egg_crocodile",
    "alexsmobs:crow": "alexsmobs:spawn_egg_crow",
    //"alexsmobs:devils_hole_pupfish": "alexsmobs:spawn_egg_devils_hole_pupfish", // Disabled: supposed to be rare
    "alexsmobs:dropbear": "alexsmobs:spawn_egg_dropbear",
    "alexsmobs:elephant": "alexsmobs:spawn_egg_elephant",
    "alexsmobs:emu": "alexsmobs:spawn_egg_emu",
    "alexsmobs:endergrade": "alexsmobs:spawn_egg_endergrade",
    "alexsmobs:enderiophage": "alexsmobs:spawn_egg_enderiophage",
    //"alexsmobs:farseer": "alexsmobs:spawn_egg_farseer", // Disabled: griefing
    "alexsmobs:flutter": "alexsmobs:spawn_egg_flutter",
    "alexsmobs:fly": "alexsmobs:spawn_egg_fly",
    "alexsmobs:flying_fish": "alexsmobs:spawn_egg_flying_fish",
    "alexsmobs:frilled_shark": "alexsmobs:spawn_egg_frilled_shark",
    "alexsmobs:froststalker": "alexsmobs:spawn_egg_froststalker",
    "alexsmobs:gazelle": "alexsmobs:spawn_egg_gazelle",
    "alexsmobs:gelada_monkey": "alexsmobs:spawn_egg_gelada_monkey",
    "alexsmobs:giant_squid": "alexsmobs:spawn_egg_giant_squid",
    "alexsmobs:gorilla": "alexsmobs:spawn_egg_gorilla",
    "alexsmobs:grizzly_bear": "alexsmobs:spawn_egg_grizzly_bear",
    "alexsmobs:guster": "alexsmobs:spawn_egg_guster",
    "alexsmobs:hammerhead_shark": "alexsmobs:spawn_egg_hammerhead_shark",
    "alexsmobs:hummingbird": "alexsmobs:spawn_egg_hummingbird",
    "alexsmobs:jerboa": "alexsmobs:spawn_egg_jerboa",
    "alexsmobs:kangaroo": "alexsmobs:spawn_egg_kangaroo",
    "alexsmobs:komodo_dragon": "alexsmobs:spawn_egg_komodo_dragon",
    "alexsmobs:laviathan": "alexsmobs:spawn_egg_laviathan",
    "alexsmobs:leafcutter_ant": "alexsmobs:spawn_egg_leafcutter_ant",
    "alexsmobs:lobster": "alexsmobs:spawn_egg_lobster",
    "alexsmobs:maned_wolf": "alexsmobs:spawn_egg_maned_wolf",
    "alexsmobs:mantis_shrimp": "alexsmobs:spawn_egg_mantis_shrimp",
    "alexsmobs:mimic_octopus": "alexsmobs:spawn_egg_mimic_octopus",
    //"alexsmobs:mimicube": "alexsmobs:spawn_egg_mimicube", // Disabled: op mimicream farm
    "alexsmobs:moose": "alexsmobs:spawn_egg_moose",
    "alexsmobs:mudskipper": "alexsmobs:spawn_egg_mudskipper",
    "alexsmobs:mungus": "alexsmobs:spawn_egg_mungus",
    "alexsmobs:murmur": "alexsmobs:spawn_egg_murmur",
    "alexsmobs:orca": "alexsmobs:spawn_egg_orca",
    "alexsmobs:platypus": "alexsmobs:spawn_egg_platypus",
    "alexsmobs:potoo": "alexsmobs:spawn_egg_potoo",
    "alexsmobs:raccoon": "alexsmobs:spawn_egg_raccoon",
    "alexsmobs:rain_frog": "alexsmobs:spawn_egg_rain_frog",
    "alexsmobs:rattlesnake": "alexsmobs:spawn_egg_rattlesnake",
    "alexsmobs:rhinoceros": "alexsmobs:spawn_egg_rhinoceros",
    "alexsmobs:roadrunner": "alexsmobs:spawn_egg_roadrunner",
    "alexsmobs:rocky_roller": "alexsmobs:spawn_egg_rocky_roller",
    "alexsmobs:seagull": "alexsmobs:spawn_egg_seagull",
    "alexsmobs:seal": "alexsmobs:spawn_egg_seal",
    "alexsmobs:shoebill": "alexsmobs:spawn_egg_shoebill",
    "alexsmobs:skelewag": "alexsmobs:spawn_egg_skelewag",
    "alexsmobs:skreecher": "alexsmobs:spawn_egg_skreecher",
    "alexsmobs:skunk": "alexsmobs:spawn_egg_skunk",
    "alexsmobs:snow_leopard": "alexsmobs:spawn_egg_snow_leopard",
    "alexsmobs:soul_vulture": "alexsmobs:spawn_egg_soul_vulture",
    "alexsmobs:spectre": "alexsmobs:spawn_egg_spectre",
    "alexsmobs:straddler": "alexsmobs:spawn_egg_straddler",
    "alexsmobs:stradpole": "alexsmobs:spawn_egg_stradpole",
    "alexsmobs:sugar_glider": "alexsmobs:spawn_egg_sugar_glider",
    //"alexsmobs:sunbird": "alexsmobs:spawn_egg_sunbird", // Disabled: supposed to be rare
    "alexsmobs:tarantula_hawk": "alexsmobs:spawn_egg_tarantula_hawk",
    "alexsmobs:tasmanian_devil": "alexsmobs:spawn_egg_tasmanian_devil",
    "alexsmobs:terrapin": "alexsmobs:spawn_egg_terrapin",
    "alexsmobs:tiger": "alexsmobs:spawn_egg_tiger",
    "alexsmobs:toucan": "alexsmobs:spawn_egg_toucan",
    "alexsmobs:tusklin": "alexsmobs:spawn_egg_tusklin",
    "alexsmobs:underminer": "alexsmobs:spawn_egg_underminer",
    //"alexsmobs:void_worm": "alexsmobs:spawn_egg_void_worm", // Disabled: boss mob
    //"alexsmobs:warped_mosco": "alexsmobs:spawn_egg_warped_mosco", // Disabled: boss mob
    "alexsmobs:warped_toad": "alexsmobs:spawn_egg_warped_toad",

    //"aquaculture:arrau_turtle": "aquaculture:arrau_turtle_spawn_egg", // Disabled: mob is disabled
    //"aquaculture:box_turtle": "aquaculture:box_turtle_spawn_egg", // Disabled: mob is disabled
    //"aquaculture:starshell_turtle": "aquaculture:starshell_turtle_spawn_egg", // Disabled: mob is disabled
    
    //"ars_nouveau:drygmy": "ars_nouveau:drygmy_se", // Disabled: supposed to find in wild
    //"ars_nouveau:starbuncle": "ars_nouveau:starbuncle_se", // Disabled: supposed to find in wild
    //"ars_nouveau:whirlisprig": "ars_nouveau:whirlisprig_se", // Disabled: supposed to find in wild
    "ars_nouveau:wilden_guardian": "ars_nouveau:wilden_guardian_se",
    "ars_nouveau:wilden_hunter": "ars_nouveau:wilden_hunter_se",
    "ars_nouveau:wilden_stalker": "ars_nouveau:wilden_stalker_se",
    
    "babyfat:ranchu": "babyfat:ranchu_spawn_egg",
    
    "cnb:cactem": "cnb:cactem_spawn_egg",
    "cnb:cindershell": "cnb:cindershell_spawn_egg",
    "cnb:end_whale": "cnb:end_whale_spawn_egg",
    "cnb:lilytad": "cnb:lilytad_spawn_egg",
    "cnb:little_grebe": "cnb:little_grebe_spawn_egg",
    "cnb:lizard": "cnb:lizard_spawn_egg",
    "cnb:minipad": "cnb:minipad_spawn_egg",
    // sporelings have special implementation, see below
    "cnb:yeti": "cnb:yeti_spawn_egg",
    
    "creeperoverhaul:badlands_creeper": "creeperoverhaul:badlands_creeper_spawn_egg",
    "creeperoverhaul:bamboo_creeper": "creeperoverhaul:bamboo_creeper_spawn_egg",
    "creeperoverhaul:beach_creeper": "creeperoverhaul:beach_creeper_spawn_egg",
    "creeperoverhaul:cave_creeper": "creeperoverhaul:cave_creeper_spawn_egg",
    "creeperoverhaul:dark_oak_creeper": "creeperoverhaul:dark_oak_creeper_spawn_egg",
    "creeperoverhaul:desert_creeper": "creeperoverhaul:desert_creeper_spawn_egg",
    "creeperoverhaul:dripstone_creeper": "creeperoverhaul:dripstone_creeper_spawn_egg",
    "creeperoverhaul:hills_creeper": "creeperoverhaul:hills_creeper_spawn_egg",
    "creeperoverhaul:jungle_creeper": "creeperoverhaul:jungle_creeper_spawn_egg",
    "creeperoverhaul:mushroom_creeper": "creeperoverhaul:mushroom_creeper_spawn_egg",
    "creeperoverhaul:ocean_creeper": "creeperoverhaul:ocean_creeper_spawn_egg",
    "creeperoverhaul:savannah_creeper": "creeperoverhaul:savannah_creeper_spawn_egg",
    "creeperoverhaul:snowy_creeper": "creeperoverhaul:snowy_creeper_spawn_egg",
    "creeperoverhaul:spruce_creeper": "creeperoverhaul:spruce_creeper_spawn_egg",
    "creeperoverhaul:swamp_creeper": "creeperoverhaul:swamp_creeper_spawn_egg",
    
    "crittersandcompanions:dragonfly": "crittersandcompanions:dragonfly_spawn_egg",
    "crittersandcompanions:dumbo_octopus": "crittersandcompanions:dumbo_octopus_spawn_egg",
    "crittersandcompanions:ferret": "crittersandcompanions:ferret_spawn_egg",
    "crittersandcompanions:jumping_spider": "crittersandcompanions:jumping_spider_spawn_egg",
    "crittersandcompanions:koi_fish": "crittersandcompanions:koi_fish_spawn_egg",
    "crittersandcompanions:leaf_insect": "crittersandcompanions:leaf_insect_spawn_egg",
    "crittersandcompanions:otter": "crittersandcompanions:otter_spawn_egg",
    "crittersandcompanions:red_panda": "crittersandcompanions:red_panda_spawn_egg",
    "crittersandcompanions:sea_bunny": "crittersandcompanions:sea_bunny_spawn_egg",
    "crittersandcompanions:shima_enaga": "crittersandcompanions:shima_enaga_spawn_egg",
    
    "deeperdarker:sculk_centipede": "deeperdarker:sculk_centipede_spawn_egg",
    "deeperdarker:sculk_leech": "deeperdarker:sculk_leech_spawn_egg",
    "deeperdarker:sculk_snapper": "deeperdarker:sculk_snapper_spawn_egg",
    "deeperdarker:shattered": "deeperdarker:shattered_spawn_egg",
    "deeperdarker:shriek_worm": "deeperdarker:shriek_worm_spawn_egg",
    "deeperdarker:stalker": "deeperdarker:stalker_spawn_egg",
    
    "duckling:duck": "duckling:duck_spawn_egg",
    //"duckling:quackling": "duckling:quackling_spawn_egg", // Disabled: infinite traders
    
    "ecologics:camel": "ecologics:camel_spawn_egg",
    "ecologics:coconut_crab": "ecologics:coconut_crab_spawn_egg",
    "ecologics:penguin": "ecologics:penguin_spawn_egg",
    "ecologics:squirrel": "ecologics:squirrel_spawn_egg",
    
    //"minecraft:iron_golem": "spawnermod:iron_golem_spawn_egg", // Disabled: op iron farm
    
    "environmental:deer": "environmental:deer_spawn_egg",
    "environmental:duck": "environmental:duck_spawn_egg",
    "environmental:koi": "environmental:koi_spawn_egg",
    "environmental:reindeer": "environmental:reindeer_spawn_egg",
    "environmental:slabfish": "environmental:slabfish_spawn_egg",
    "environmental:tapir": "environmental:tapir_spawn_egg",
    "environmental:yak": "environmental:yak_spawn_egg",
    "environmental:zebra": "environmental:zebra_spawn_egg",
    
    "extendedmushrooms:mushroom_sheep": "extendedmushrooms:mushroom_sheep_spawn_egg",
    
    //"friendsandfoes:copper_golem": "friendsandfoes:copper_golem_spawn_egg", // Disable: op copper farm
    "friendsandfoes:crab": "friendsandfoes:crab_spawn_egg",
    "friendsandfoes:glare": "friendsandfoes:glare_spawn_egg",
    //"friendsandfoes:iceologer": "friendsandfoes:iceologer_spawn_egg", // Disable: op totem farm
    //"friendsandfoes:illusioner": "friendsandfoes:illusioner_spawn_egg", // Disable: op totem farm
    //"friendsandfoes:mauler": "friendsandfoes:mauler_spawn_egg", // Disable: mob is disabled
    "friendsandfoes:moobloom": "friendsandfoes:moobloom_spawn_egg",
    //"friendsandfoes:rascal": "friendsandfoes:rascal_spawn_egg", // Disable: can't kill mob?
    //"friendsandfoes:tuff_golem": "friendsandfoes:tuff_golem_spawn_egg", // Disable: tuff can be crushed into metals
    //"friendsandfoes:wildfire": "friendsandfoes:wildfire_spawn_egg", // Disable: boss mob
    
    //"goblintraders:goblin_trader": "goblintraders:goblin_trader_spawn_egg", // Disable: infinite traders
    //"goblintraders:vein_goblin_trader": "goblintraders:vein_goblin_trader_spawn_egg", // Disable: infinite traders
    
    "hexerei:crow": "hexerei:crow_spawn_egg",
    "hexerei:owl": "hexerei:owl_spawn_egg",
    
    "kakapos:kakapo": "kakapos:kakapo_spawn_egg",
    
    "mythicmounts:acencia": "mythicmounts:acencia_spawn_egg",
    "mythicmounts:archelon": "mythicmounts:archelon_spawn_egg",
    "mythicmounts:colelytra": "mythicmounts:colelytra_spawn_egg",
    "mythicmounts:courierbird": "mythicmounts:courierbird_spawn_egg",
    "mythicmounts:direwolf": "mythicmounts:direwolf_spawn_egg",
    "mythicmounts:dragon": "mythicmounts:dragon_spawn_egg",
    "mythicmounts:firebird": "mythicmounts:firebird_spawn_egg",
    "mythicmounts:geckotoalizard": "mythicmounts:geckotoalizard_spawn_egg",
    "mythicmounts:griffon": "mythicmounts:griffon_spawn_egg",
    "mythicmounts:moth": "mythicmounts:moth_spawn_egg",
    "mythicmounts:netherbat": "mythicmounts:netherbat_spawn_egg",
    "mythicmounts:nightmare": "mythicmounts:nightmare_spawn_egg",
    "mythicmounts:nudibranch": "mythicmounts:nudibranch_spawn_egg",
    "mythicmounts:ridinglizard": "mythicmounts:ridinglizard_spawn_egg",
    
    "netherdepthsupgrade:blazefish": "netherdepthsupgrade:blazefish_spawn_egg",
    "netherdepthsupgrade:bonefish": "netherdepthsupgrade:bonefish_spawn_egg",
    "netherdepthsupgrade:eyeball_fish": "netherdepthsupgrade:eyeball_fish_spawn_egg",
    "netherdepthsupgrade:fortressgrouper": "netherdepthsupgrade:fortress_grouper_spawn_egg",
    "netherdepthsupgrade:glowdine": "netherdepthsupgrade:glowdine_spawn_egg",
    "netherdepthsupgrade:lava_pufferfish": "netherdepthsupgrade:lava_pufferfish_spawn_egg",
    "netherdepthsupgrade:magmacubefish": "netherdepthsupgrade:magmacubefish_spawn_egg",
    "netherdepthsupgrade:obsidianfish": "netherdepthsupgrade:obsidianfish_spawn_egg",
    "netherdepthsupgrade:searing_cod": "netherdepthsupgrade:searing_cod_spawn_egg",
    "netherdepthsupgrade:soulsucker": "netherdepthsupgrade:soulsucker_spawn_egg",
    "netherdepthsupgrade:wither_bonefish": "netherdepthsupgrade:wither_bonefish_spawn_egg",
    
    "byg:man_o_war": "byg:man_o_war_spawn_egg",
    "byg:pumpkin_warden": "byg:pumpkin_warden_spawn_egg",
    
    "quark:crab": "quark:crab_spawn_egg",
    "quark:forgotten": "quark:forgotten_spawn_egg",
    "quark:foxhound": "quark:foxhound_spawn_egg",
    "quark:shiba": "quark:shiba_spawn_egg",
    "quark:stoneling": "quark:stoneling_spawn_egg",
    "quark:toretoise": "quark:toretoise_spawn_egg",
    "quark:wraith": "quark:wraith_spawn_egg",
    
    "snuffles:snuffle": "snuffles:snuffle_spawn_egg",
    
    "sprout:bounce_bug": "sprout:bouncebug_spawn_egg",
    "sprout:elephant": "sprout:elephant_spawn_egg",
    
    "swampier_swamps:dragonfly": "swampier_swamps:dragonfly_spawn_egg",
    
    //"twilightforest:adherent": "twilightforest:adherent_spawn_egg", // Disabled: mob is NYI
    //"twilightforest:alpha_yeti": "twilightforest:alpha_yeti_spawn_egg", // Disabled: progression skip for tf
    //"twilightforest:armored_giant": "twilightforest:armored_giant_spawn_egg", // Disabled: progression skip for tf
    "twilightforest:bighorn_sheep": "twilightforest:bighorn_sheep_spawn_egg",
    "twilightforest:blockchain_goblin": "twilightforest:blockchain_goblin_spawn_egg",
    "twilightforest:boar": "twilightforest:boar_spawn_egg",
    "twilightforest:carminite_broodling": "twilightforest:carminite_broodling_spawn_egg",
    "twilightforest:carminite_ghastguard": "twilightforest:carminite_ghastguard_spawn_egg",
    "twilightforest:carminite_ghastling": "twilightforest:carminite_ghastling_spawn_egg",
    //"twilightforest:carminite_golem": "twilightforest:carminite_golem_spawn_egg", // Disabled: op iron farm
    "twilightforest:death_tome": "twilightforest:death_tome_spawn_egg",
    "twilightforest:deer": "twilightforest:deer_spawn_egg",
    "twilightforest:dwarf_rabbit": "twilightforest:dwarf_rabbit_spawn_egg",
    "twilightforest:fire_beetle": "twilightforest:fire_beetle_spawn_egg",
    //"twilightforest:giant_miner": "twilightforest:giant_miner_spawn_egg", // Disabled: progression skip for tf
    //"twilightforest:harbinger_cube": "twilightforest:harbinger_cube_spawn_egg" // Disabled: mob is NYI
    "twilightforest:hedge_spider": "twilightforest:hedge_spider_spawn_egg",
    "twilightforest:helmet_crab": "twilightforest:helmet_crab_spawn_egg",
    "twilightforest:hostile_wolf": "twilightforest:hostile_wolf_spawn_egg",
    //"twilightforest:hydra": "twilightforest:hydra_spawn_egg", // Disabled: boss mob
    "twilightforest:ice_crystal": "twilightforest:ice_crystal_spawn_egg",
    "twilightforest:king_spider": "twilightforest:king_spider_spawn_egg",
    //"twilightforest:knight_phantom": "twilightforest:knight_phantom_spawn_egg", // Disabled: boss mob
    "twilightforest:kobold": "twilightforest:kobold_spawn_egg",
    //"twilightforest:lich": "twilightforest:lich_spawn_egg", // Disabled: boss mob
    "twilightforest:lower_goblin_knight": "twilightforest:lower_goblin_knight_spawn_egg",
    "twilightforest:maze_slime": "twilightforest:maze_slime_spawn_egg",
    //"twilightforest:minoshroom": "twilightforest:minoshroom_spawn_egg", // Disabled: boss mob
    "twilightforest:minotaur": "twilightforest:minotaur_spawn_egg",
    "twilightforest:mist_wolf": "twilightforest:mist_wolf_spawn_egg",
    "twilightforest:mosquito_swarm": "twilightforest:mosquito_swarm_spawn_egg",
    //"twilightforest:naga": "twilightforest:naga_spawn_egg", // Disabled: boss mob
    "twilightforest:penguin": "twilightforest:penguin_spawn_egg",
    "twilightforest:pinch_beetle": "twilightforest:pinch_beetle_spawn_egg",
    //"twilightforest:quest_ram": "twilightforest:quest_ram_spawn_egg" // Disabled: op diamond farm
    "twilightforest:raven": "twilightforest:raven_spawn_egg",
    "twilightforest:redcap_sapper": "twilightforest:redcap_sapper_spawn_egg",
    "twilightforest:redcap": "twilightforest:redcap_spawn_egg",
    //"twilightforest:roving_cube": "twilightforest:roving_cube_spawn_egg", // Disabled: mob is NYI
    "twilightforest:skeleton_druid": "twilightforest:skeleton_druid_spawn_egg",
    "twilightforest:slime_beetle": "twilightforest:slime_beetle_spawn_egg",
    "twilightforest:snow_guardian": "twilightforest:snow_guardian_spawn_egg",
    //"twilightforest:snow_queen": "twilightforest:snow_queen_spawn_egg", // Disabled: boss mob
    "twilightforest:squirrel": "twilightforest:squirrel_spawn_egg",
    "twilightforest:stable_ice_core": "twilightforest:stable_ice_core_spawn_egg",
    "twilightforest:swarm_spider": "twilightforest:swarm_spider_spawn_egg",
    "twilightforest:tiny_bird": "twilightforest:tiny_bird_spawn_egg",
    "twilightforest:towerwood_borer": "twilightforest:towerwood_borer_spawn_egg",
    "twilightforest:troll": "twilightforest:troll_spawn_egg",
    "twilightforest:unstable_ice_core": "twilightforest:unstable_ice_core_spawn_egg",
    //"twilightforest:ur_ghast": "twilightforest:ur_ghast_spawn_egg", // Disabled: boss mob
    "twilightforest:winter_wolf": "twilightforest:winter_wolf_spawn_egg",
    "twilightforest:wraith": "twilightforest:wraith_spawn_egg",
    "twilightforest:yeti": "twilightforest:yeti_spawn_egg",
}

// Technical implementation details below.

function applyEggDropLootConditions(lootPool) {
    lootPool.killedByPlayer();
    lootPool.randomChance(EGG_DROP_CHANCE);
    lootPool.matchMainHand(Ingredient.of("#forge:scythe"));
}

function addEggDrop(event, mobId, eggId) {
    event
        .addEntityLootModifier(mobId)
        .pool((pool) => {
            applyEggDropLootConditions(pool);
            pool.addLoot(eggId);
        });
}

function addSporelingEggDrops(event) {
    let netherEggEntry = LootEntry.of("cnb:sporeling_nether_egg").when((conditions) => {
        conditions.customCondition(
            {
                "condition": "minecraft:alternative",
                "terms": [
                    {
                        "condition": "minecraft:entity_properties",
                        "entity": "this",
                        "predicate": {
                            "nbt": "{SporelingType: \"cnb:red_nether\"}"
                        }
                    },
                    {
                        "condition": "minecraft:entity_properties",
                        "entity": "this",
                        "predicate": {
                            "nbt": "{SporelingType: \"cnb:brown_nether\"}"
                        }
                    }
                ]
            }
        );
    });
    let overworldEggEntry = LootEntry.of("cnb:sporeling_overworld_egg");
    

    event
        .addEntityLootModifier("cnb:sporeling")
        .pool((pool) => {
            applyEggDropLootConditions(pool);
            pool.addAlternativesLoot(netherEggEntry, overworldEggEntry);
        });
}

LootJS.modifiers((event) => {
    for (let mobId in EGGS) {
        addEggDrop(event, mobId, EGGS[mobId]);
    }
    addSporelingEggDrops(event);
});


})();
